#include <iostream>
#include <fstream>

using namespace std;

typedef long long lint;
lint max(lint a, lint b) {
	if (a >= b) {
		return a;
	}
	else {
		return b;
	}
}
lint min(lint a, lint b) {
	if (a <= b) {
		return a;
	}
	else {
		return b;
	}
}

int main() {
	ifstream in("input.txt");
	ofstream out("output.txt");
	lint a, b, k;
	in >> a >> b >> k;
	lint sum = 0;
//	out << a << " " << b << " " << k << endl;
	for (int i = 1; i < 1e6 + 1; i++) {
		int cube = i * i * i;
		if ((cube >= a) && (cube <= b)) {
//			out << cube << endl;
			lint left = max(a, cube - k);
			lint right = min(b, cube + k);
			lint sqrleft = int(sqrt(left)) - 3;
			lint sqrright = int(sqrt(right)) + 3;
			while ((sqrleft * sqrleft < left) || (sqrleft < 0))  {
				sqrleft++;
			}
			while (sqrright * sqrright > right) {
				sqrright--;
			}
//			out << sqrleft << " " << sqrright << endl;
			sum += (sqrright - sqrleft) + 1;
		}
	}
	out << sum;
}